//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "AddressDlgs.h"
#include "AddrEditDlgs.h"
#include "HelpDlgs.h"
#include "MsgWins.h"
#include "FileMan.h"
#include "HeadMan.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAddressDlg *AddressDlg;
//---------------------------------------------------------------------------
bool __fastcall GetMailRecipients(TMessageWin *Msgwin)
{
   bool didget=false;
   TAddressDlg *ad = new TAddressDlg(Msgwin);
   if (ad->Execute())
   {
      didget=true;
   }
   delete ad;
   return didget;
}
//---------------------------------------------------------------------------
__fastcall TAddressDlg::TAddressDlg(TComponent* Owner)
	: TForm(Owner)
{
   // initialize Address list
   GetAppData(AddrsList->Items,UserAddresses+PS+General);
   // initialize Newsgroups list
   GetAppData(GrpsList->Items,UserAddresses+PS+Newsgroups);
   // initialize stuff
   Msgwin = (TMessageWin*)Owner; Ed = Msgwin->Editor;
   Headman = new THeaderManager(Ed->Lines);
   OrgHeaders = new TStringList();
   for (int i=0; i<Ed->Lines->Count; i++)
   {
      AnsiString hdr = Ed->Lines->Strings[i];
      if (hdr.Trim().IsEmpty()) break;
      OrgHeaders->Add(hdr);
   }
   PageControl1->ActivePage = TabSheet1;
   Items = new TStringList();
   ToBtn->Checked = true;
   GetHeader("To: ");
   Modified = false;
}
//---------------------------------------------------------------------------
__fastcall TAddressDlg::~TAddressDlg()
{
   delete OrgHeaders;
   delete Items;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::ClearSelected(TListBox *list)
{
   for (int i=0; i<list->Items->Count; i++)
      list->Selected[i] = false;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::ParseItems(AnsiString &Hdrline)
{
   AnsiString item;
   Items->Clear();
   int i=0; while ((item=GetParam(i++,Hdrline,",").Trim())!="")
      Items->Add(item);
}
//---------------------------------------------------------------------------
int __fastcall TAddressDlg::GetHeaderPosAndDelete(AnsiString &Header)
{
   THeaderManager *headers = new THeaderManager(Ed->Lines);
   int pos=headers->Delete(Header);
   if (pos<0)
   {
      for (int i=0; i<Ed->Lines->Count; i++)
      if (Ed->Lines->Strings[i].Trim().IsEmpty())
      {
         pos = i;
         break;
      }
   }
   delete headers;
   return pos;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::GetHeader(AnsiString &Name)
{
   int pos;
   AnsiString hdrline = Headman->GetDat(Name);
   ParseItems(hdrline);
   if (PageControl1->ActivePage==TabSheet1)
   {
      ClearSelected(AddrsList);
      for (int i=0; i<Items->Count; i++)
         if ((pos=AddrsList->Items->IndexOf(Items->Strings[i]))>=0)
            AddrsList->Selected[pos] = true;
   }
   else
   {
      ClearSelected(GrpsList);
      for (int i=0; i<Items->Count; i++)
         if ((pos=GrpsList->Items->IndexOf(Items->Strings[i]))>=0)
            GrpsList->Selected[pos] = true;
   }
   //AppProcessMessages(); Sleep(100);
   Hdrname = Name;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::SetHeader(AnsiString &Name)
{
   int pos;
   AnsiString header;
   SetRedraw(Msgwin,0);

   for (int i=0; i<Items->Count; i++)
      header += Items->Strings[i]+",\r\n ";
   header = header.SubString(1,header.Length()-4);
   if ((pos=GetHeaderPosAndDelete(Name))>=0)
      Ed->Lines->Insert(pos,Name+header);
   AppProcessMessages(); Sleep(100);

   SetRedraw(Msgwin,1);
   Modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::GetChkdHeader()
{
   if (ToBtn->Checked) GetHeader("To: "); else
   if (CcBtn->Checked) GetHeader("Cc: "); else
   if (BcBtn->Checked) GetHeader("Bcc: ");
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::SetChkdHeader()
{
   if (ToBtn->Checked) SetHeader("To: "); else
   if (CcBtn->Checked) SetHeader("Cc: "); else
   if (BcBtn->Checked) SetHeader("Bcc: ");
}
//---------------------------------------------------------------------------
bool __fastcall TAddressDlg::Execute()
{
   CenterDialog(this,AppMainForm);
   AppProcessMessages();
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::EditAddrBtnClick(TObject *Sender)
{
   if (EditAddressesEtc(AddrsList->Items,NULL,this))
      PutAppData(UserAddresses+PS+General,AddrsList->Items);
   GetChkdHeader();
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::EditGrpsBtnClick(TObject *Sender)
{
   if (EditAddressesEtc(NULL,GrpsList->Items,this))
      PutAppData(UserAddresses+PS+Newsgroups,GrpsList->Items);
   GetHeader("Newsgroups: ");
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::AddrsListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   SetRedraw(this,false);
   if (PageControl1->ActivePage==TabSheet1)
      GetHeader("Newsgroups: ");
   else GetChkdHeader();
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::PageControl1Change(TObject *Sender)
{
   SetRedraw(this,true);
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("AddressBook","Address Book","",(TForm*)Owner);
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::GrpsListClick(TObject *Sender)
{
   int i,pos;
   TStrings *glist = GrpsList->Items;
   for (i=0; i<glist->Count; i++)
   {
      if (GrpsList->Selected[i] && Items->IndexOf(glist->Strings[i])<0)
         Items->Add(glist->Strings[i]);
   }
   i=0; while (i<Items->Count)
   {
      if ((pos=glist->IndexOf(Items->Strings[i]))>=0 && !GrpsList->Selected[pos])
         Items->Delete(i);
      else i++;
   }
   CancelBtn->Caption = "Cancel";
   SetHeader("Newsgroups: ");
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::AddrsListClick(TObject *Sender)
{
   int i,pos;
   TStrings *alist = AddrsList->Items;
   for (i=0; i<alist->Count; i++)
   {
      if (AddrsList->Selected[i] && Items->IndexOf(alist->Strings[i])<0)
         Items->Add(alist->Strings[i]);
   }
   i=0; while (i<Items->Count)
   {
      if ((pos=alist->IndexOf(Items->Strings[i]))>=0 && !AddrsList->Selected[pos])
         Items->Delete(i);
      else i++;
   }
   CancelBtn->Caption = "Cancel";
   SetChkdHeader();
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::ToBtnClick(TObject *Sender)
{
   if (Hdrname!="To: ") GetChkdHeader();
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::CcBtnClick(TObject *Sender)
{
   if (Hdrname!="Cc: ") GetChkdHeader();
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::BcBtnClick(TObject *Sender)
{
   if (Hdrname!="Bcc: ") GetChkdHeader();
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::GroupsBtnClick(TObject *Sender)
{
   if (Hdrname!="Newsgroups: ") GetHeader("Newsgroups: ");
}
//---------------------------------------------------------------------------
void __fastcall TAddressDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && Modified)
   {
      switch (MsgBoxHwnd(Handle,
         "Your headers have been modified.\n\nSave your changes?","Confirm",
          MB_YESNOCANCEL))
      {
         case IDNO:
            Cursor = crHourGlass;
            while (Ed->Lines->Count && !Ed->Lines->Strings[0].Trim().IsEmpty())
               Ed->Lines->Delete(0);
            OrgHeaders->AddStrings(Ed->Lines);
            Ed->Lines->Text = OrgHeaders->Text;
            AppProcessMessages(); Sleep(200);
            CancelBtn->Caption = "Close";
            Cursor = crDefault;
            break;
         case IDCANCEL:
            CanClose = false;
            break;
      }
   }
   Ed->SelStart = 0;
}
//---------------------------------------------------------------------------
