//---------------------------------------------------------------------------
#ifndef GlobalH
#define GlobalH
#include <ShlObj.h>
#include <vcl\comctrls.hpp>
#include <time.h>
//---------------------------------------------------------------------------
#define AppMainForm Application->MainForm
#define AppProcessMessages() Application->ProcessMessages();
const AnsiString AppExeName = Application->ExeName.UpperCase();
const AnsiString AppDir = ExtractFilePath(AppExeName).LowerCase();
#define ISDESIGNING (FileExists(ChangeFileExt(AppExeName,".dsk")))
//const AnsiString AppExe(QS.exe); -- is in version.h

const AnsiString UninstDat = "uninst.dat";  // uninstall info
const AnsiString SetupLog = "setuplog.txt"; // install log
const keeplog = true; // create setuplog.txt during installation

#define BUGREPORTADDRESS GetAppIni("BugReportAddress","",AppIni)

const AnsiString ClearTextMessageFollows = "<--Clear-text message follows------------->";
const AnsiString PgpButtonsHdr = "Pgp-Buttons: ";
const AnsiString PgpHdr = "Pgp: ";
const AnsiString NymHdr = "Nym: ";

const bool off = false;
const bool on = true;

#define s(s) AnsiString(s)
#define sm(m) ShowMessage(s(m))
#define MsgBoxHwnd(h,m,t,b) MessageBox(HWND(h),String(m).c_str(),String(t).c_str(),b)
#define MsgBox(m,t,b) MsgBoxHwnd(Application->MainForm->Handle,m,t,b)
#define CutMarks  GetAppIni("Cutmarks","~~")
#define QteMarks  GetAppIni("QteMarks","> ")
//#define MixUseExe GetAppIni("MixUseExe","1").ToIntDef(1)

#define WM_QUEUECHANGE    WM_USER+1
#define WM_PROBLEMCHANGE  WM_USER+2
#define WM_UPDATECHECKED  WM_USER+3
#define WM_UPDATEENABLE   WM_USER+4
#define WM_CHECKUPDATE    WM_USER+5
#define WM_SETBUTTONS     WM_USER+6
#define WM_GETERRORLOG    WM_USER+7
#define WM_OPENPROBLEMS   WM_USER+8
#define WM_OPENQUEUE      WM_USER+9
#define WM_LOADBOXMENU    WM_USER+10
#define WM_INSERTFILENAME WM_USER+11
#define WM_DISPLAYXY      WM_USER+12
#define WM_REFRESHINDEX	WM_USER+13
#define WM_INCOMINGMAIL   WM_USER+15
#define WM_OPENINBOX      WM_USER+16
#define WM_STOREPOPLOG    WM_USER+17
#define WM_SENDMAIL       WM_USER+18
#define WM_SETWINCURSOR   WM_USER+19
#define WM_SHOWSTATUS     WM_USER+21
#define WM_SAVEQUIT       WM_USER+22
#define WM_OPENADDRESSES  WM_USER+23
#define WM_OPENHELP       WM_USER+24
#define WM_EDITMENU       WM_USER+25
#define WM_GETBUTTONCLICK WM_USER+26
#define WM_HELPWINPOS     WM_USER+27
#define WM_OPENKEYMAN     WM_USER+28
#define WM_NEXTMESSAGE    WM_USER+100  // smtp
#define WM_NEXTPOP        WM_USER+101  // pop3
//===================================
#define WM_DATREQUEST     WM_USER+20
#define GetDatData           (WORD)1
#define PutDatData           (WORD)2
//===================================
#define WM_SAVEBTNCLICKED  WM_USER+201
#define WM_REFRESHBTNCLICKED  WM_USER+202
#define WM_IMPORTBTNCLICKED  WM_USER+203
#define WM_DISABLEBTNCLICKED  WM_USER+204
#define WM_DELETEBTNCLICKED  WM_USER+205
#define WM_AREYOUKEYWINDOW  WM_USER+206
#define WM_AREYOUPGPKEYWINDOW  WM_USER+207
#define WM_AREYOUMIXKEYWINDOW  WM_USER+208
#define WM_AREYOUMIXPROBWINDOW  WM_USER+209
#define WM_KEYRINGCONFIGITEMCLICKED  WM_USER+210
#define WM_KEYRINGOPENDOCITEMCLICKED  WM_USER+211
#define WM_KEYRINGCLEARITEMCLICKED  WM_USER+212
#define WM_KEYRINGNEWKEYITEMCLICKED  WM_USER+214
#define WM_GETKEYRINGMENUDAT  WM_USER+215

#define WM_DOPGP6UPDATE       WM_USER+216
#define WM_GETSESSIONKEY      WM_USER+217
#define WM_WIPEFILE           WM_USER+218
// nym messages
#define WM_OPENNYMMESSAGE	  WM_USER+219
#define WM_GETMERGEMESSAGE	  WM_USER+220

#define WM_UPDATEPGPKEYWIN	  WM_USER+221
//============================================
// used by mix and pgp to set mainform keyring menu
class KeyringMenuDat
{
public:
   bool Modified;
   bool HasSel;
   bool RefreshEnabled;
   bool CurEnabled;
   bool IsPair;
   int Count;
};

//#define DEFNYMOPS AnsiString("+acksend -signsend +cryptrecv -fixedsize -disable -fingerkey -nobcc")
const AnsiString QSpop3Name("QSpop3.dll");
const AnsiString QSpgpName("QSpgp.dll");
const AnsiString QSpgp6Name("QSpgp6.dll");
const AnsiString QSpgp5Name("QSpgp5.dll");
const AnsiString QSnymName("QSnym.dll");
const AnsiString HelpWinPos = "HelpWinPos";

const AnsiString QuickStart = "QuickStart.rtf";
const AnsiString QuickStartPop3 = "QuickStart.Pop3.rtf";
const AnsiString QuickStartPgp = "QuickStart.Pgp.rtf";
const AnsiString QuickStartNym = "QuickStart.Nym.rtf";

const bool UseDialog = true;

const AnsiString DatExt(".dbc");
const AnsiString PooExt(".dpc");
const AnsiString PgpExt(".pgp");
const AnsiString IniExt(".ini");
const AnsiString BakExt(".bak");
const AnsiString TmpExt(".tmp");
const AnsiString OrgExt(".org");

//const AnsiString OriginalKey = "Originals";

const AnsiString AppDat = ChangeFileExt(AppExeName,DatExt);
const AnsiString AppIni = ChangeFileExt(AppExeName,IniExt);
const AnsiString AppPgp = ChangeFileExt(AppExeName,PgpExt);
const AnsiString AppPgpBak = AppPgp+BakExt;
const AnsiString AppPgpTmp = AppPgp+TmpExt;
const AnsiString IniUpdateOnSend = "UpdateOnSend";

//#define PS PATHSEPARATOR // in fileman.h
const AnsiString AppIniValues   = "Initialization";
const AnsiString FindHistory    = "FindHistory";
const AnsiString UserNyms       = "Nyms";
const AnsiString UserNotes      = "Notes";
const AnsiString WasUserMessages= "Messages";
const AnsiString UserMessages   = "Drafts";
const AnsiString UserTemplates  = "Templates";
const AnsiString UserAddresses  = "Address Book";
const AnsiString UserMailboxes  = "Mailboxes";
const AnsiString UserData       = "User Data";
const AnsiString MailQueue      = "Mail Queue";
const AnsiString ProblemQueue   = "Problems Queue";
const AnsiString MailboxBoxmenu = "Mailbox Menu";    // boxes included on mailbox menu
const AnsiString MailboxPos     = "Mailbox Pos";  // position of cursor in box index
const AnsiString StatsURLs      = "StatsURLs";
const AnsiString HttpInfo       = "Http Info";
const AnsiString FtpProxy       = "Ftp Proxy";
const AnsiString UseFtpProxy    = "Use Ftp Proxy";
const AnsiString MixValues      = "Mixmaster";
const AnsiString PopAccounts    = "Pop Accounts";
const AnsiString PopLastMsgId   = "Last Message-ID";
const AnsiString UpdateSites    = "Update Sites";
const AnsiString UpdateWizTimeout = "Update Wiz Timeout";
const AnsiString StatsTimeOut   = "Stats Timeout";
const AnsiString Pop3TimeOut    = "Pop3 TimeOut";
const AnsiString ErrChkLog      = "ErrorChecksLog";
const AnsiString ErrChkLogMax   = "ErrChkLogMax";
const AnsiString POP3Log        = "Pop3Log";
const AnsiString POP3LogMax     = "Pop3LogMax";
const AnsiString SMTPLog        = "SmtpLog";
const AnsiString SMTPLogMax     = "SmtpLogMax";
const AnsiString ChainLog       = "ChainLog";
const AnsiString ChainLogMax    = "ChainLogMax";
const AnsiString CpunkShorts    = "CpunkShorts";
const AnsiString Cyberpunk      = "Cyberpunk";
const AnsiString CpkKeyUpdate   = "CpkKeyUpdate";
const AnsiString Mixmaster      = "Mixmaster";
const AnsiString MixKeyUpdate   = "MixKeyUpdate";
const AnsiString MixAutoChecked = "MixAuto";
const AnsiString CorruptReport  = "*****Corrupt Report*****";
const AnsiString StatsCopies    = "StatsKeepCopies";
const AnsiString StatsErrCheck  = "StatsErrorCheck";
#define STATSBAKCOPIES (GetAppIni(StatsCopies,"").ToIntDef(3))
const AnsiString KeyringCopies   = "KeyringsKeepCopies";
#define KEYRINGBAKCOPIES (GetAppIni(KeyringCopies,"").ToIntDef(3))
const AnsiString OpenRevisionNotes = "OpenRevisionNotes";
const AnsiString MailboxesSorted  = "MailboxesSorted";
#define MAILBOXESSORTED (GetAppIni(MailboxesSorted,"1")=="1")
const AnsiString Pgp6AutoImport = "Pgp6AutoImport";
const AnsiString PgpPubRing     = "PgpPublicRing";
const AnsiString PgpSecRing     = "PgpSecretRing";
const AnsiString PgpImpRing     = "PgpImportRing";
#define PGP6AUTOUPDATE (GetAppIni(Pgp6AutoImport,"1")=="1")
const AnsiString PgpCachePassMinutes = "PgpCachePassMinutes";
const AnsiString OpenBetaTestDialog = "OpenBetaTestDialog";
#define OPENBETATESTDIALOG (GetAppIni(OpenBetaTestDialog,"1")=="1")
#define OPENBETATESTDIALOGSET(val) (PutAppIni(OpenBetaTestDialog,(val==false?"0":"1")))

//const AnsiString PgpImportFile  = "";
//const AnsiString PgpOriginals   = "Pgp Originals";

//const AnsiString TempBugReportFile = "QSTemplateBugReport.txt";
//const AnsiString BugReport       = "BugReport";

const AnsiString AppRandPool     = "RandomPool"; // MixValues+PS+AppRandPool
const AnsiString MixClientCfg    = "ClientCfg";

const AnsiString DatExePath      = "exe";
const AnsiString UnzipApp        = "unzipping.exe";

const AnsiString POP3YouGotMail  = "You got mail!";
const AnsiString POP3SorryNoMail = "Sorry, no new mail.";
const AnsiString POP3UserCancel  = "User cancel";
const AnsiString POP3ErrorAbort  = "Error: aborted!";

// statistics filenames (and datakeys)
const AnsiString MixImportDir = "MixImportDir"; // dir where qs looks for importing mix keys
const AnsiString CpkImportDir = "CpkImportDir"; // dir where qs looks for importing cpk keys
const AnsiString PgpImportDir = "PgpImportDir"; //                                  pgp
const AnsiString PgpExportDir = "PgpExportDir";

const AnsiString MixKeepDisabled = "MixKeepDis";

const AnsiString MListTxt = "mlist.txt";
const AnsiString MRingTxt = "pubring.mix";
const AnsiString MProbTxt = "problem.mix";
const AnsiString MRingTmp =  MRingTxt+".tmp";
const AnsiString MTyp2Txt = "type2.list";

const AnsiString CListTxt = "rlist.txt";
const AnsiString CListTmp =  CListTxt+".tmp";
const AnsiString CRingTxt = "pubring.asc";
const AnsiString CRingTmp =  CRingTxt+".tmp";
const AnsiString CTyp1Txt = "type1.list";
const AnsiString CProbTxt = "problem.cpk";

const bool nosave = false;
const bool save = true;

#define mlisttxt MixDir()+MListTxt
#define mprobtxt MixDir()+MProbTxt
#define mringtxt MixDir()+MRingTxt
#define mtyp2txt MixDir()+MTyp2Txt

#define clisttxt MixDir()+CListTxt
#define clisttmp MixDir()+CListTmp
#define cprobtxt MixDir()+CProbTxt
#define cringtxt MixDir()+CRingTxt
#define cringtmp MixDir()+CRingTmp
#define ctyp1txt MixDir()+CTyp1Txt

#define deletespgp MixDir()+"deletes.pgp"

// used for def keyring names when importing pgp keys
const AnsiString PGPPubRing = AppDir+"pubring.pkr";
const AnsiString PGPSecRing = AppDir+"secring.skr";
const int SleepTime = 100;
const int DesignPixelsPerInch = 96;

const AnsiString WordWrapHeader = "Word-Wrap: ";
// preferences
const AnsiString QuoteMarks = "QteMarks";
const AnsiString StatsMinUpdates = "StatsMinUpdates";
const AnsiString WordWrap = "WordWrap";
const AnsiString WordWrapShowBox = "WordWrapShowBox";
const AnsiString DontWrapQuoted = "DontWrapQuoted";
const AnsiString SendWrapChars = "SendWrapChars";
const AnsiString SendWrapCharsCount = "SendWrapCharsCount";
const AnsiString SendDateHdr = "SendDateHdr";
#define ADDDATEHEADER (GetAppIni(SendDateHdr,"0")=="1")
const AnsiString SendWrapWin = "SendWrapWin";
const AnsiString SendWrapNot = "SendWrapNot";
const AnsiString EdFontName = "FontName";
const AnsiString EdFontSize = "FontSize";
const AnsiString WorkSpaceColor = "WorkSpaceColor";
const AnsiString ClearSignMessage = "ClearSignMessage";
const AnsiString KeepPasswordMin = "KeepPasswordMin";
#define KEEPPASSWORDMIN  (GetAppIni(KeepPasswordMin,"").ToIntDef(0))
const AnsiString EnableCyberpunk = "EnableCyberpunk";
#define CYBERPUNKENABLED (GetAppIni(EnableCyberpunk,"0")=="1" || true)

// 'true' lets me always enable cpunk while avoiding 'expression is
//  always true' warning
// menu ID used by setup.exe, uninst.exe, for 'About...' on system menu
#define IDS_CUSTOMSYSMENUITEM 0x1000

#define AddBS(dir) AddBackslash(dir)
#define RemBS(dir) RemoveBackslash(dir)
TStrings* __fastcall TrimNullsBefore(TStrings *strings);
TStrings* __fastcall TrimNullsAfter(TStrings *strings);
TStrings* __fastcall TrimNullsStart(TStrings *strings);
TStrings* __fastcall TrimNullsEnd(TStrings *strings);
TStrings* __fastcall TrimNulls(TStrings *strings);
AnsiString __fastcall GetEAddress(AnsiString useridstr); // returns uid@server.com
void __fastcall Snooze(int seconds);
AnsiString __fastcall UnixDateStr();
void __fastcall SaveToFileNoWrap(TRichEdit *Editor, AnsiString &FileName);
void __fastcall GetUnWrappedText(TRichEdit *Editor, TStrings *ToStrings);
void __fastcall SetRedraw(TWinControl *window, bool set);
TColor __fastcall GetColor16(int Index);
void __fastcall ClearString(AnsiString &str);
AnsiString __fastcall GetLastErrorStr();
bool DiskInDrive(char drive);
bool __fastcall SetRunOnce(const AnsiString Name, const AnsiString RunCmd);
void __fastcall MyBeep(WORD BeepType=MB_OK);
bool __fastcall DeleteDirectory(AnsiString &pathname);
HINSTANCE __fastcall ExploreFolder(AnsiString &strFolder);
HANDLE __fastcall Exec95(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
DWORD __fastcall ExecAndWait95(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
AnsiString __fastcall GetShortFileName(AnsiString &FileName);
AnsiString __fastcall GetWindowsDir();
AnsiString __fastcall GetTempDir();
AnsiString __fastcall GetTempFilename();
void __fastcall CopyToClipboard(TStrings *Text);
void __fastcall PasteFromClipboard(TStrings *Text);  // meno OR riched
void __fastcall PasteFromClipboard(TCustomMemo *Editor);
void __fastcall CenterDialog(TForm *CenteredForm, TForm *MainForm=Application->MainForm);
AnsiString __fastcall GetToken(int pos, AnsiString &fromBuf, char *divider, char *def="");
AnsiString __fastcall GetParam(int pos, AnsiString &fromBuf, char *divider=",", char *def="");
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr);
int __fastcall GetFilenames(TStrings *names, AnsiString &pathname, int attrib=faAnyFile);
AnsiString __fastcall AddBackslash(AnsiString path);
AnsiString __fastcall RemoveBackslash(AnsiString path);
HRESULT CreateLink(AnsiString TargetPath, AnsiString LinkPath, AnsiString IconPath,
   AnsiString Description, AnsiString Params);
bool __fastcall RegKeyExists(AnsiString &Key);
void __fastcall BufSaveToFileBak(byte* buffer, int length, AnsiString &docname, int bakcopies);
void __fastcall SaveToFileBak(TStrings *Document, AnsiString &FileName, int bakcopies);
void __fastcall FileSaveToFileBak(AnsiString &TmpFile, AnsiString &FileName, int bakcopies);
AnsiString __fastcall bak(AnsiString &name, int baknumber);

extern bool DoMyBeep;
extern bool PGP6updated;
//---------------------------------------------------------------------------
#endif
